<?php




class logDB {
/*

create table userInfo (
    time,
    ipaddr,
    token,
    schoolName,
    className,
    userName,
    videoName,
    finishTime,
    timeline
);

create table videoLog (
    time,
    ipaddr,
    token,
    mode,
    moviefile,
    statement
);

 */
    private $dbfile = 'db/log.db';
    private $db;
    private $ipaddr;
    
    function __construct(){
        $this->db = new PDO("sqlite:{$this->dbfile}");
        $this->ipaddr = $_SERVER['REMOTE_ADDR'];
    }
    
    function setUser($userInfo, $time=null){   
        $token = $this->random(16);
        if(is_null($time)) $time = time();
        
        $stmt = $this->db->prepare("insert into userInfo (time, ipaddr, token, schoolName, className, userName, videoName) values (:ipaddr, :time, :token, :schoolName, :className, :userName, :videoName)");
        $stmt->execute(array(':ipaddr'=>$this->ipaddr, ':time'=>$time,':token'=>$token,
                             ':schoolName'=>$userInfo[0],
                             ':className'=>$userInfo[1],
                             ':userName'=>$userInfo[2],
                             ':videoName'=>$userInfo[3] ));
        return($token);
    }
    function getUser($token){
        $stmt = $this->db->prepare("select * from userInfo where token = :token");
        if($stmt->execute(array(':token'=>$token))){
            $record = $stmt->fetch();
            
            return($record);
        } else {
            return(false);
        }
    }
    function getWatchLog($className, $userName){
        $query = "select * from userInfo where className = :className and userName = :userName";
        
        $stmt = $this->db->prepare("select * from userInfo where token = :token");
        $stmt = $this->db->prepare($query);
        $result = $stmt->execute(array(':className'=>$className, ':userName'=>$userName));
        
        if(!$result) return(false);
        
        $r_val=array();
        while($record = $stmt->fetch(PDO::FETCH_ASSOC)){
            $r_val[] = $record;
        }
        return($r_val);
    }
    function getAllWatchLog($className=null){
        $query = "select * from userInfo order by className,videoName";
        
        $stmt = $this->db->prepare($query);
        $result = $stmt->execute(array(':className'=>$className, ':userName'=>$userName));
        
        if(!$result) return(false);
        
        $r_val=array();
        while($record = $stmt->fetch(PDO::FETCH_ASSOC)){
            $r_val[] = $record;
        }
        return($r_val);
    }
    
    private function random($length = 8)
    {
        // citation: http://qiita.com/suin/items/c958bcca90262467f2c0
        return substr(base_convert(md5(uniqid()), 16, 36), 0, $length);
    }
    
    function setLog($ipaddr,$time,$token,$mode,$moviefile,$statement){
        $stmt = $this->db->prepare("insert into videoLog (ipaddr, time, token, mode, moviefile, statement) values (:ipaddr, :time, :token, :mode, :moviefile, :statement)");
        $stmt->execute(array(':ipaddr'=>$ipaddr, ':time'=>$time,':token'=>$token,':mode'=>$mode, ':moviefile'=>$moviefile, ':statement'=>$statement));
    }
    function setFinishedLog($token,$finishTime){
        $stmt = $this->db->prepare("update userInfo set finishTime = :finishTime where token = :token and finishTime is null");
        $result = $stmt->execute(array(':token'=>$token, ':finishTime'=>$finishTime));
        
        if($result){
            return($stmt->rowCount());
        } else {
            return(false);
        }
    }
    function setTimeline($token,$timeline){
	/* $tl = array();
	foreach($timeline as $time => $t){
		if($t) $tl[$time] = 1; else $tl[$time] = 0;
	}
	$timeline = json_encode($tl);
	$timeline = count($timeline);*/
        $stmt = $this->db->prepare("update userInfo set timeline = :timeline where token = :token");
        $result = $stmt->execute(array(':token'=>$token, ':timeline'=>$timeline));

        if($result){
            return($stmt->rowCount());
        } else {
            return(false);
        }
    }

}
?>
